Cabal-2.0.1.0: A framework for packaging Haskell software

Safe Haskell | None
Language | Haskell2010

Distribution.Backpack.ModSubst

Description

A type class `ModSubst` for objects which can have `ModuleSubst` applied to them.

See also https://github.com/ezyang/ghc-proposals/blob/backpack/proposals/0000-backpack.rst

Synopsis

- class ModSubst a where

# Documentation

class ModSubst a where #

Applying module substitutions to semantic objects.

Minimal complete definition

modSubst

Methods

modSubst :: OpenModuleSubst -> a -> a #

Instances

ModSubst OpenModule # |
Methods modSubst :: OpenModuleSubst -> OpenModule -> OpenModule #
ModSubst OpenUnitId # |
Methods modSubst :: OpenModuleSubst -> OpenUnitId -> OpenUnitId #
ModSubst ModuleShape # |
Methods modSubst :: OpenModuleSubst -> ModuleShape -> ModuleShape #
ModSubst a => ModSubst [a] # |
Methods modSubst :: OpenModuleSubst -> [a] -> [a] #
ModSubst (Set ModuleName) # |
Methods modSubst :: OpenModuleSubst -> Set ModuleName -> Set ModuleName #
ModSubst a => ModSubst (k, a) # |
Methods modSubst :: OpenModuleSubst -> (k, a) -> (k, a) #
ModSubst a => ModSubst (Map k a) # |
Methods modSubst :: OpenModuleSubst -> Map k a -> Map k a #